Attribute VB_Name = "basUnchk"
Option Explicit
Declare Sub Sleep Lib "kernel32" (ByVal lngMilliseconds As Long)

Function JustName(strFileName As String) As String
Dim strTemp As String
Dim intCounter As Integer
' Accepts any path\filename, returns just the filename
    strTemp = strFileName
    If InStr(strTemp, "\") <> 0 Then
        intCounter = Len(strTemp)
        Do Until Mid(strTemp, intCounter, 1) = "\"
            intCounter = intCounter - 1
        Loop
        JustName = Mid(strTemp, intCounter + 1)
    Else
        If InStr(strTemp, ":") <> 0 Then
            JustName = Mid(strTemp, 3)
        Else
            JustName = strTemp
        End If
    End If
End Function

Function JustExtension(strFileName As String) As String
'  Returns everything after the last dot
Dim strTemp As String
Dim intCounter As Integer
    strTemp = JustName(strFileName)
    If InStr(strTemp, ".") <> 0 Then
        intCounter = Len(strTemp)
        Do Until Mid(strTemp, intCounter, 1) = "."
                intCounter = intCounter - 1
        Loop
        JustExtension = Mid(strTemp, intCounter + 1)
    Else
        JustExtension = ""
    End If
End Function

Function JustPath(strFileName As String) As String
' Accepts any path\file, returns just the path
Dim intCounter As String
Dim strTemp As String
    strTemp = strFileName
    If InStr(strTemp, "\") <> 0 Then
        intCounter = Len(strTemp)
        Do Until Mid(strTemp, intCounter, 1) = "\"
            intCounter = intCounter - 1
        Loop
        JustPath = Left$(strTemp, intCounter)
    Else
        If InStr(strTemp, ":") <> 0 Then
            JustPath = Left(strTemp, 2)
        Else
            JustPath = ""
        End If
    End If
End Function

Sub Main()
Dim strKeys As String
Dim strKey As String
Dim strIniEntry As String
Dim strExtension As String
Dim strHeader As String
Dim strContains As String
Dim strFileName As String
Dim strData As String
Dim strCommand As String
Dim strMessage As String
Dim strSourcePath As String
Dim strFileMask As String
Dim strDestPath As String
Dim lngCount As Long
Dim lngMax As Long
Dim lngScanDepth As Long
Dim lngTotalFiles As Long
Dim lngFileCount As Long
Dim blnKeepLog As Boolean
Dim blnRecoveredFile As Boolean
Dim fs As Object


    'The Scripting.FileSystem object is required.
    Set fs = Nothing
    On Error Resume Next
    Set fs = CreateObject("Scripting.FileSystemObject")
    If fs Is Nothing Then
        MsgBox "This program requires the ""Windows Scripting Host"". Please download and install Windows Scripting from msdn.microsoft.com/scripting"
        Exit Sub
    End If
    
    InitializeIniFile
    
    'We will get a file name as the argument
    strCommand = Command$
    
    'Does the user need help with hex encode/decode?
    If strCommand = "/encode" Then
        strMessage = "Enter any text and I'll hex ENCODE it for you. Press Cancel to quit."
        strCommand = "Hello world!"
        Do While strCommand <> ""
            strCommand = HexEncode(InputBox(strMessage, "UnChk - Hex Encode", strCommand))
        Loop
        Exit Sub
    End If
    If strCommand = "/decode" Then
        strMessage = "Enter any text and I'll hex DECODE it for you. Press Cancel to quit."
        strCommand = HexEncode("Hello world!")
        Do While strCommand <> ""
            strCommand = HexDecode(InputBox(strMessage, "UnChk - Hex Decode", strCommand))
        Loop
        Exit Sub
    End If
    
    'Did we get something other than a CHK file as argument?
    If strCommand <> "" Then
        'Remove the quotes
        If Left(strCommand, 1) = """" Then strCommand = Mid(strCommand, 2)
        If Right(strCommand, 1) = """" Then strCommand = Left(strCommand, Len(strCommand) - 1)
        If UCase(Right(strCommand, 4)) <> ".CHK" Then
            'Add an INI file entry
            If fs.FileExists(strCommand) Then
                Open strCommand For Binary Access Read As #1
                SetIni UCase(JustExtension(strCommand)), HexEncode(Input(2, 1))
                Close #1
                MsgBox "Best-guess file header information for " & UCase(JustExtension(strCommand)) & " file types has been added to the INI file."
            Else
                MsgBox Chr(34) & strCommand & Chr(34) & " isn't a file"
            End If
            Exit Sub
        End If
    End If
    
    'We will use the argument as the source path
    'If we got no command line, ask the user
    If strCommand = "" Then
        strSourcePath = AskPath()
    Else
        strSourcePath = JustPath(strCommand)
    End If
    If strSourcePath = "" Then Exit Sub
    If Right(strSourcePath, 1) <> "\" Then strSourcePath = strSourcePath & "\"
    
    strFileMask = strSourcePath & "*.chk"
    
    'Ask for the destination path
    frmSaveAs.drvSaveAs.Drive = strSourcePath
    frmSaveAs.dirSaveAs.Path = strSourcePath
    frmSaveAs.Show vbModal
    strDestPath = frmSaveAs.Tag
    Unload frmSaveAs
    If strDestPath = "" Then Exit Sub
    If Right(strDestPath, 1) <> "\" Then strDestPath = strDestPath & "\"
    
    'Ask for the scan depth
    frmDepth.Show vbModal
    Select Case frmDepth.Tag
        Case "0"
            lngScanDepth = 0
        Case "1"
            lngScanDepth = 1
        Case "2"
            lngScanDepth = 128
        Case "3"
            lngScanDepth = 512
        Case ""
            lngScanDepth = 512
        Case Else
            lngScanDepth = 512
    End Select
    If frmDepth.chkLog = 1 Then
        blnKeepLog = True
    Else
        blnKeepLog = False
    End If
    Unload frmDepth
    
    'Light it up
    frmStatus.Show
    frmStatus.lblStatus.Caption = ""
    DoEvents
    
    'Count the files
    lngTotalFiles = 0
    strFileName = Dir(strFileMask)
    Do Until strFileName = ""
        lngTotalFiles = lngTotalFiles + 1
        strFileName = Dir()
    Loop
    
    'Check each file
    strFileName = Dir(strFileMask)
    lngFileCount = 0
    On Error Resume Next
    Do Until strFileName = ""
        blnRecoveredFile = False
        lngFileCount = lngFileCount + 1
        frmStatus.lblFileNameStatus.Caption = CStr((100 * lngFileCount) \ lngTotalFiles) & "%" & "  -  " & JustName(strFileName)
        frmStatus.lblFileTypeStatus.Caption = ""
        DoEvents
        Err.Clear
        Open strSourcePath & strFileName For Binary Access Read As #1
        strData = Input(LOF(1), 1)
        Close #1
        If Err.Number <> 0 Then
            Err.Clear
            If blnKeepLog Then WriteLog Now & vbTab & strFileName & vbTab & "ERROR READING FILE"
            frmStatus.lblStatus.Caption = "ERROR READING FILE"
            DoEvents
            Sleep 1000
        Else
            'Check every known header for this file
            strKeys = KeyNames()
            Do While InStr(strKeys, Chr(0)) <> 0
                strKey = Left(strKeys, InStr(strKeys, Chr(0)) - 1)
                strKeys = Mid(strKeys, InStr(strKeys, Chr(0)) + 1)
                If ((strKey <> "Program") And (strKey <> "IniFile")) Then
                    If ProcessChkFile(strData, strKey, strDestPath, strFileName, lngScanDepth) Then
                        If blnKeepLog Then WriteLog Now & vbTab & strFileName & vbTab & strKey
                        blnRecoveredFile = True
                    End If
                End If
            Loop
            If strKeys <> "" Then 'Do the last item in the list
                strKey = strKeys
                If ((strKey <> "Program") And (strKey <> "IniFile")) Then
                    If ProcessChkFile(strData, strKey, strDestPath, strFileName, lngScanDepth) Then
                        If blnKeepLog Then WriteLog Now & vbTab & strFileName & vbTab & strKey
                        blnRecoveredFile = True
                    End If
                End If
            End If
            If blnRecoveredFile = False Then
                If blnKeepLog Then WriteLog Now & vbTab & strFileName
            End If
        End If
        strFileName = Dir()
    Loop
    
    'Turn it off
    Unload frmStatus

End Sub

Function HexDecode(strText As String) As String
Dim strBuffer As String
Dim strGoodText As String
Dim lngPosition As Long
    For lngPosition = 1 To Len(strText)
        If InStr("0123456789abcdefABCDEF", Mid(strText, lngPosition, 1)) <> 0 Then
            strGoodText = strGoodText & Mid(strText, lngPosition, 1)
        End If
    Next
    For lngPosition = 1 To Len(strGoodText) Step 2
        strBuffer = strBuffer & Chr("&H" & Mid(strGoodText, lngPosition, 2))
    Next
    HexDecode = strBuffer
End Function

Function HexEncode(strString As String) As String
Dim strBuffer As String
Dim lngPos As Long
    For lngPos = 1 To Len(strString)
        strBuffer = strBuffer & Right("0" & Hex(Asc(Mid(strString, lngPos, 1))), 2)
    Next
    HexEncode = strBuffer
End Function

Function AskPath() As String
Dim strMessage As String
Dim strSourcePath As String
    strMessage = "      You can supply a file name as an argument by dropping "
    strMessage = strMessage & "it on the UNCHK.EXE file entry. This "
    strMessage = strMessage & "help screen will appear when you do not supply an argument."
    strMessage = strMessage & Chr$(13) & Chr$(10)
    strMessage = strMessage & "      If you drop a CHK file on UNCHK, it will attempt "
    strMessage = strMessage & "to recover all CHK files in that same directory. If you drop any other "
    strMessage = strMessage & "type of file on this program, an entry will be generated "
    strMessage = strMessage & "in the INI file to help identify "
    strMessage = strMessage & "files of that type in the future. You can also manually edit the INI file "
    strMessage = strMessage & "to modify or add new file types. "
    strMessage = strMessage & Chr$(13) & Chr$(10)
    strMessage = strMessage & "      Your original CHK "
    strMessage = strMessage & "files are not altered. UNCHK creates copies when it recovers files. UNCHK cannot identify the ends of files or tell if they extend "
    strMessage = strMessage & "into another CHK file. "
    strMessage = strMessage & Chr$(13) & Chr$(10)
    strMessage = strMessage & "      There is a limit to how many "
    strMessage = strMessage & "files are allowed in a root directory. You may have to move your "
    strMessage = strMessage & "CHK files into a subdirectory."
    strMessage = strMessage & Chr$(13) & Chr$(10)
    strMessage = strMessage & "      This utility may not work on your system. If it does, "
    strMessage = strMessage & "you're welcome to it.   Eric Phelps http://www.ericphelps.com"
    MsgBox strMessage
    frmSelect.Show vbModal
    strSourcePath = frmSelect.Tag
    Unload frmSelect
    If strSourcePath = "" Then End
    If Right(strSourcePath, 1) <> "\" Then strSourcePath = strSourcePath & "\"
    If Dir(strSourcePath & "*.chk") = "" Then
        MsgBox "Unable to find CHK files in that directory. Program will now terminate so you can locate your CHK files."
        AskPath = ""
    Else
        AskPath = strSourcePath
    End If
End Function

Function ProcessChkFile(ByRef strData As String, strKey As String, strDestPath As String, strFileName As String, lngScanDepth As Long) As Boolean
'Returns True if recovered file
Dim strExtension As String
Dim strHeader As String
Dim strContains As String
Dim strRecoveredFile As String
Dim strIniEntry As String
Dim lngCount As Long
Dim intCount As Integer
Dim lngByteCount As Long
Dim varData() As Byte
Dim fs As Object
Dim blnRecovered As Boolean

    If strData = "" Then
        ProcessChkFile = False
        Exit Function
    End If
    
    Set fs = CreateObject("Scripting.FileSystemObject")
    frmStatus.lblFileTypeStatus.Caption = strKey
    DoEvents
    blnRecovered = False
    strExtension = strKey
    strIniEntry = Trim(GetIni(strKey))
    If strIniEntry = "" Then
        ProcessChkFile = False
        Exit Function
    End If
    
    If InStr(strIniEntry, " ") = 0 Then
        strHeader = HexDecode(strIniEntry)
        strContains = ""
    Else
        strHeader = HexDecode(Left(strIniEntry, InStr(strIniEntry, " ") - 1))
        strContains = HexDecode(Mid(strIniEntry, InStr(strIniEntry, " ") + 1))
    End If
    
    If strHeader = "" Then
        ProcessChkFile = False
        Exit Function
    End If
    
    If lngScanDepth = 0 Then
        If Left(strData, Len(strHeader)) = 1 Then
            If InStr(strData, strContains) <> 0 Then
                blnRecovered = True
                frmStatus.lblStatus.Caption = "RECOVERING"
                DoEvents
                strRecoveredFile = strDestPath & RootName(JustName(strFileName)) & "." & strExtension
                intCount = 0
                Do While fs.FileExists(strRecoveredFile)
                    intCount = intCount + 1
                    strRecoveredFile = strDestPath & RootName(JustName(strFileName)) & "-" & CStr(intCount) & "." & strExtension
                Loop
                String2File strData, strRecoveredFile
                frmStatus.lblStatus.Caption = ""
            End If
        End If
    Else
        For lngCount = 1 To Len(strData) Step lngScanDepth
            If Mid(strData, lngCount, Len(strHeader)) = strHeader Then
                If InStr(lngCount, strData, strContains) <> 0 Then
                    blnRecovered = True
                    frmStatus.lblStatus.Caption = "RECOVERING"
                    DoEvents
                    strRecoveredFile = strDestPath & RootName(JustName(strFileName)) & "." & strExtension
                    intCount = 0
                    Do While fs.FileExists(strRecoveredFile)
                        intCount = intCount + 1
                        strRecoveredFile = strDestPath & RootName(JustName(strFileName)) & "-" & CStr(intCount) & "." & strExtension
                    Loop
                    String2File Mid(strData, lngCount), strRecoveredFile
                    frmStatus.lblStatus.Caption = ""
                End If
            End If
        Next
    End If
    
    ProcessChkFile = blnRecovered
    
End Function

Sub WriteLog(strText As String)
Dim fs As Object
Dim ts As Object
Const ForAppending = 8
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set ts = fs.OpenTextFile(fs.BuildPath(App.Path, LCase(App.EXEName) & ".log"), ForAppending, True)
    ts.WriteLine strText
    ts.Close
End Sub

Sub String2File(ByRef strData, strFileName)
'Writes a string to a file
Dim fs As Object
Dim ts As Object
Dim lngChar As Long
Dim strBlock As String
Dim intChar As Integer
Const ForWriting = 2
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set ts = fs.OpenTextFile(strFileName, ForWriting, True)
    Err.Clear
    On Error Resume Next
    ts.Write strData
    If Err.Number <> 0 Then
        'Must have hit one of the "problem characters" between 128 and 159
        For lngChar = 1 To Len(strData) Step 100
            Err.Clear
            ts.Write Mid(strData, lngChar, 100)
            If Err.Number <> 0 Then
                'This block of 100 must have the problem. Write them one-at-a-time
                strBlock = Mid(strData, lngChar, 100)
                For intChar = 1 To Len(strBlock)
                    ts.Write Chr(255 And AscW(Mid(strBlock, intChar)))
                Next
            End If
        Next
    End If
    ts.Close
End Sub
Function RootName(strFileName As String) As String
'  Accepts raw file name and extension only
'  (in the form FILENAME.EXT) DOES NOT ACCEPT
'  PATH NAMES. Returns the root name without
'  the extension. Works okay even on filenames
'  that have no extensions.
    If InStr(strFileName, ".") <> 0 Then
        RootName = Left(strFileName, InStr(strFileName, ".") - 1)
    Else
        RootName = strFileName
    End If
End Function

